-- get_palette() and set_palette()

-- I found a way to read and set the individual DAC palette with 
-- interrupts. I know there is a routine for setting individual palette 
-- entries in Euphoria, however, the set_palette routine included below 
-- appears to be about 30% faster than the built in routine. Get_palette is 
-- also included. Please feel free to use this if it helps.

-- Greg Harris
-- Hollow Horse Software
include machine.e

global function get_palette(integer index)
--get palette entry index and return {r,g,b} for index
    sequence regs
    integer val1, val2, val3
    if index < 0 then index = 0 end if
    if index > 255 then index = 255 end if
    regs = repeat(0,10)
    regs[REG_AX] = #1015
    regs[REG_BX] = index
    regs = dos_interrupt(#10,regs)
    --green
    val1 = and_bits(regs[REG_CX], #FF00) / 256
    --blue
    val2 = and_bits(regs[REG_CX], #FF)
    --red
    val3 = and_bits(regs[REG_DX], #FF00) / 256
    return {val3,val1,val2} --{r,g,b}
end function
-----------------------------------------------------------------

global procedure set_palette(integer index, sequence color)
    --similar to Euphoria's palette() command
    --Set palette entry index with color {r,g,b}
    sequence regs
    regs = repeat(0, 10)
    regs[REG_AX] = #1010
    regs[REG_BX] = index
    regs[REG_CX] = color[2] * 256 + color[3]
    regs[REG_DX] = color[1] * 256
    regs = dos_interrupt(#10, regs)
end procedure

global procedure ZIGSwitchPal(sequence CurC)
                for z = 0 to 15 do
                    set_palette(z, CurC[z + 1])
                end for
end procedure


