-- zobjects.e
-- ZIG object routines

global constant
    -- Object constants
    OBJECT_ATTRIB_ELEMENTS=4,
    MAX_OBJS_PER_BOARD=6010,NUM_OBJECT_SETTINGS=17,OBJ_BOARD_NUM=1,OBJ_X=2,
    OBJ_Y=3,OBJ_LAYER=4,OBJ_CHAR=5,OBJ_COLOR=6,OBJ_DISPMODE=7,OBJ_POS=8,
    OBJ_RUNSTATE=9,OBJ_LOCKED=10,OBJ_CYCLE=11,OBJ_NAME=12,
    OBJ_FOCUS=13,OBJ_PROPS=14,OBJ_HALTED=32762
    
global sequence 
        Objects, ObjectPosTable, OneObject, 
        GrabbedObject
        
include zsidebar.e
include zboards.e

global procedure BuildObjectTable(atom Board)
    
    ObjectPosTable = repeat(repeat(repeat(0, 3), 80), 25)
    
    if length(Objects) then
        for z = 1 to length(Objects) do
            if Objects[z][1][OBJ_BOARD_NUM] = Board then
                ObjectPosTable
                        [Objects[z][1][OBJ_X]]
                        [Objects[z][1][OBJ_Y]]
                        [Objects[z][1][OBJ_LAYER]] = z
            end if        
        end for
    end if
end procedure

global procedure UpdateObjectTable(atom Obj, atom Board, atom RemFlag)
-- Put RemFlag to !=0 to delete an object from the table
    if Obj < length(Objects) + 1 then
        for x = 1 to 25 do
            for y = 1 to 80 do
                for z = 1 to 3 do
                    if ObjectPosTable[x][y][z] = Obj then
                        ObjectPosTable[x][y][z] = 0
                        if Objects[z][1][OBJ_BOARD_NUM] = Board
                        and not RemFlag then
                            ObjectPosTable
                                    [Objects[z][1][OBJ_X]]
                                    [Objects[z][1][OBJ_Y]]
                                    [Objects[z][1][OBJ_LAYER]] = Obj
                            exit exit exit
                        end if
                    end if
                end for
            end for
        end for
    end if
    
end procedure

global procedure DeleteObject(atom Obj, atom Board)

    -- Remove from table
    if Board != 0 then UpdateObjectTable(Obj, Board, TRUE) end if

    if Obj < length(Objects) + 1 then
        if Obj = length(Objects) then
            Objects = Objects[1..length(Objects) - 1]
        elsif Obj = 1 then
            if length(Objects) > 1 then
                Objects = Objects[2..length(Objects)]
            else Objects = {}
            end if
        else
            if Obj = 1 then
                Objects = Objects[2..length(Objects)]
            elsif Obj = length(Objects) then
                Objects = Objects[1..length(Objects) - 1]
            else
                Objects = Objects[1..Obj - 1] & Objects[Obj + 1..length(Objects)]
            end if
        end if
    end if    

end procedure

global procedure NewObject(object Props, atom AddToTable)
    if not sequence(Props) then
        Objects = append(Objects, OneObject)
        AddToTable = FALSE
    else
        Objects = append(Objects, {Props})
    end if

    if AddToTable then
        ObjectPosTable
            [Objects[length(Objects)][1][OBJ_X]]
            [Objects[length(Objects)][1][OBJ_Y]]
            [Objects[length(Objects)][1][OBJ_LAYER]] = length(Objects)
    end if    
    
end procedure


