-- zsie.e
-- sie 1.0
-- ZIG object program editor

include graphics.e

include zgfx.e

-- sie editor code segment --------------------------------------------------

global procedure sie_Redraw(sequence Ed, atom X, atom Y)
    atom RealX

    bk_color(1)
    
    clear_screen()
    
    text_color(14)
    bk_color(4)
    puts(1, " sie 1.0 ")
    
    text_color(0)
    bk_color(3)
    
    position(25, 1)
    printf(1, " %2d, %2d  Esc - quit editor ", {X, Y})

    text_color(15)
    bk_color(1)
        
    for z = 2 to 24 do
        RealX = (X - 12) + z
        
        if RealX = 0 or RealX = length(Ed) + 1 then
            position(z, 1)
            text_color(9)
            for a = 1 to 8 do
                puts(1, "    -    ")
            end for
            text_color(15)
        end if

        if RealX > 0 and RealX < length(Ed) + 1 then
            position(z, 1)
            for a = 1 to length(Ed[RealX]) do
                puts(1, Ed[RealX][a])
            end for
        end if
    end for

    position(12, Y + 1)
end procedure

global procedure sie_InitDisplay()

    bk_color(1)
    cursor(UNDERLINE_CURSOR)
    
    clear_screen()
    
    text_color(14)
    bk_color(4)
    puts(1, "sie 0.9a - beta 4 ")
    
    text_color(15)
    bk_color(1)
end procedure

global function sie_Ed(sequence Ed)
    atom Key, X, Y, OldX, OldY
    sequence Buf, SS
    
    SS = SaveScreen()
    sie_InitDisplay()
    
    X = 1
    Y = 1

    sie_Redraw(Ed, X, 1)
    
    while 1 do
        OldX = X
        OldY = Y
        
        Key = get_key()
        if Key = KEY_UP then
            X = X - 1
        elsif Key = KEY_DN then
            X = X + 1
        elsif Key = KEY_LF then
            Y = Y - 1
        elsif Key = KEY_RT then
            Y = Y + 1
        elsif Key = KEY_HOME then
            Y = 1
            sie_Redraw(Ed, X, Y)
        elsif Key = KEY_END then
            Y = length(Ed[X])
            sie_Redraw(Ed, X, Y)
        elsif Key = 8 then          -- Backspace
            if Y != 1 then
                Buf = Ed[X][1..Y - 1]
                for z = Y + 1 to length(Ed[X]) do
                    Buf = append(Buf, Ed[X][z])
                end for
                
                Ed[X] = Buf

                Y = Y - 1
                
                sie_Redraw(Ed, X, Y)
            else                    -- deleting a line w/ bksp
                if length(Ed) != 1 then
                    if length(Ed[X]) = 1 then
                        Ed[X] = {}
                    elsif length(Ed[X]) = 0 then
                        if X = length(Ed) then
                            Ed = Ed[1..length(Ed) - 1]
                        else
                            Buf = Ed[1..X - 1]
                            
                            for z = X + 1 to length(Ed) do
                                Buf = append(Buf, Ed[z]) 
                            end for
                            
                            Ed = Buf
                        end if
                    end if
                    
                    X = X - 1
                    
                    sie_Redraw(Ed, X, Y)
                end if
            end if
        elsif Key = KEY_CR then

            if X = length(Ed) then
                Ed = append(Ed, {})
            else
                Buf = Ed[1..X]
                Buf = append(Buf, {})
                
                for z = X + 1 to length(Ed) do
                    Buf = append(Buf, Ed[z])
                end for
                
                Ed = Buf
            end if
            
            X = X + 1
            Y = 1

            sie_Redraw(Ed, X, Y)
            
        elsif Key = KEY_ESC then
            cursor(NO_CURSOR)
            ResScreen(SS)
            return Ed
        elsif Key != -1 then
            if Y != length(Ed[X]) then
                if length(Ed[X]) = 0 then
                    Ed[X] = append(Ed[X], Key)
                else
                    Ed[X][Y + 1] = Key
                end if
            else
                Ed[X] = append(Ed[X], Key)
            end if
            Y = Y + 1

            sie_Redraw(Ed, X, Y)
        end if
        
        if X != OldX then
            if X < 1 then
                X = 1
            elsif X > length(Ed) then
                X = length(Ed)
            end if
        end if
        
        if Y != OldY then
            if Y < 1 then
                Y = 1
            elsif Y > length(Ed[X]) then
                Y = length(Ed[X])
            end if
            position(12, Y + 1)
        end if
        
        if X != OldX then
            Y = 1

            sie_Redraw(Ed, X, Y)
            position(12, Y + 1)
        end if
    end while
    
end function

-- end of sie editor code segment -------------------------------------------


